package puppet;

import org.apache.axis.utils.CLOption;
import org.apache.axis.wsdl.WSDL2Java;
import org.apache.axis.wsdl.gen.Parser;

import java.util.Vector;

public class WSDL2JavaCreator extends WSDL2Java
{
	
    private Vector <CLOption> opts;

    public WSDL2JavaCreator(String destination){
        this.createStandardOptions(destination);                
    }

    private void createStandardOptions(String destination){
        CLOption option;
        opts = new Vector<CLOption>();
        
        option = new CLOption(org.apache.axis.wsdl.WSDL2Java.SERVER_OPT);
        opts.add(option);
        
        option = new CLOption(org.apache.axis.wsdl.WSDL2Java.SKELETON_DEPLOY_OPT);
        option.addArgument("true");
        opts.add(option);
        
        option = new CLOption(org.apache.axis.wsdl.WSDL2Java.OUTPUT_OPT);
        option.addArgument(destination);
        opts.add(option);        
    }

    public void createAStub(String wsdl){
        for (int i=0; i < opts.size(); i++){
            this.parseOption(opts.get(i));
        }
        
// The next step should be executed, but currenlty is raise an execption.
// I did not understand why. But the wsdl2java tool seems to work correctely anyway.        
//        this.validateOptions();
                
        Parser wsdlParser = this.getParser();
        try {
            wsdlParser.run(wsdl);
        } catch (Exception e) {}        
    }
}
