package puppet;


import java.io.File;
import java.util.HashMap;
import java.util.StringTokenizer;

import org.apache.axis.wsdl.toJava.Utils;
import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
public class WSDD_Finder 
{
	private HashMap<String, String> namespacesMap;
    
    public WSDD_Finder(){
        namespacesMap = new HashMap<String, String>();        
    }
	
	public HashMap<String, String> wsdl2wsddLocation (String path)
	{
//		System.out.println(path);
        String targetNamespaceString;
        String packageNameString;
        String locationString;

        StringTokenizer st=null;
		File file=new File(path);
		String [] wsdlFileList = file.list();
        
		for(int i=0;i<wsdlFileList.length;i++)
		{
			
			try
			{
				st=new StringTokenizer(wsdlFileList[i],".");
				st.nextToken();
				String temp = st.nextToken();
				if(temp.equals("wsdl"))
				{
					//System.out.println(elenco_file[i]);
					//Generazione delle classi tramite la chiamata esterna al WSDL2JAVA
					DOMParser parser = new DOMParser();
					parser.parse(path+wsdlFileList[i]);
					Document document = parser.getDocument();
					Node nodo = document.getFirstChild();
                    nodo.getAttributes().getNamedItem("targetNamespace");
                    
                    targetNamespaceString = nodo.getAttributes().getNamedItem("targetNamespace").getNodeValue(); 
                    packageNameString = Utils.makePackageName(targetNamespaceString); 
                    locationString = packageNameString.replace('.','/');
                    locationString += "/";
                                       
//                    System.out.println(targetNamespaceString);
//                    System.out.println(packageNameString);
//                    System.out.println(locationString);
                    
                    namespacesMap.put(wsdlFileList[i], locationString);
                    
					//System.out.println();
				}
			}
			catch(Exception e){}

		}
		return namespacesMap;
	}

}
