package puppet;


import it.cnr.isti.setest0.mappedSLO.MappedSLODocument;
import it.cnr.isti.setest0.puppetSLO.PuppetSLODocument.PuppetSLO;
import it.cnr.isti.setest0.puppetScope.PuppetScopeDocument.PuppetScope;

import org.antlr.stringtemplate.StringTemplate;

public class WorkLoad 
{
	public WorkLoad(){}
	
	public String prepareWorkLoad(PuppetSLO puppet,String TipoObligated,PuppetScope puppetScope,MappedSLODocument puppet_slomapped)
	{
		System.out.println("prepareWorkload");
		String StringReady = "";
		if(TipoObligated.equals("ServiceConsumer"))  
		{
			if(puppet.getWorkLoad()!=null)
			{
				
				String Finestra = "";
				String num_connessioni = "";
				String WorkLoad_string = "";
				StringTemplate WorkLoad_string_templ = null;
				//System.out.println(puppetScope.getWorkLoadTarget());
				String Method = puppetScope.getWorkLoadTarget().getMethod();
				String Service = puppetScope.getWorkLoadTarget().getService();
				try
				{
					System.out.println("------------------------------------------------");
					System.out.println("Workload");
					if(puppet.getWorkLoad().getDistribution().getPoisson()!=null)
					{
						
						String intensity = puppet.getWorkLoad().getDistribution().getPoisson().getIntensity().toString();			
						Finestra = puppet.getWorkLoad().getWorkloadWindow().toString();
						num_connessioni = puppet.getWorkLoad().getWorkloadConnection().toString();
						WorkLoad_string = puppet_slomapped.getMappedSLO().getWorkLoad().getDistribution().getPoisson();
						WorkLoad_string_templ = new StringTemplate(WorkLoad_string);
						WorkLoad_string_templ.setAttribute("WLConnection", num_connessioni);
						WorkLoad_string_templ.setAttribute("WLWindow", Finestra);
						WorkLoad_string_templ.setAttribute("intensity",intensity);
						WorkLoad_string_templ.setAttribute("Service",Service);
						WorkLoad_string_templ.setAttribute("Method",Method);
						StringReady = StringReady + WorkLoad_string_templ.toString();

					}	
					if(puppet.getWorkLoad().getDistribution().getGaussian()!=null);
					{			
						Finestra = puppet.getWorkLoad().getWorkloadWindow().toString();
						num_connessioni = puppet.getWorkLoad().getWorkloadConnection().toString();
						WorkLoad_string = puppet_slomapped.getMappedSLO().getWorkLoad().getDistribution().getGaussian();
						WorkLoad_string_templ = new StringTemplate(WorkLoad_string);
						WorkLoad_string_templ.setAttribute("WLConnection", num_connessioni);
						WorkLoad_string_templ.setAttribute("WLWindow", Finestra);
						WorkLoad_string_templ.setAttribute("Service",Service);
						WorkLoad_string_templ.setAttribute("Method",Method);
						
						
						StringReady = StringReady + WorkLoad_string_templ.toString();
					}
				}
				//Se viene generata un'eccezione allora vuol dire che utilizziamo la gaussiana
				catch(Exception e)
				{System.out.println("workload"+e);}
			
			}
		}
		//System.out.println(StringReady);
		return StringReady;
	}
}
